<template>
  <div class="goodsInfo container-grid">
    <div
      v-if="goodsInfo.images.length"
      class="goodsInfo-slider area-slider">
      <!-- TODO - в бд есть запчасти с несколькими изображениями, необходимо реализовать -->
      <div class="picture">
        <img
          :src="goodsInfo.images[0].src"
          :alt="goodsInfo.images[0].alt"
          @click="onClickChooseImg(goodsInfo.images[0].src)">
      </div>
    </div>

    <div
      v-if="goodsInfo.aliases"
      class="goodsInfo-block area-aliases">
      <div class="goodsInfo-title">Другие названия</div>
      <div
        class="goodsInfo-text"
        :class="{'-hidden': isAliasesTextHidden }">
        {{ goodsInfo.aliases }}
        <AppButton
          class="buttonAsLink buttonMore"
          @click.native="isAliasesTextHidden = !isAliasesTextHidden">
          <template
            v-if="goodsInfo.aliases.length > 120"
            #button-item>
            {{ isAliasesTextHidden ? 'см.все' : 'свернуть' }}
          </template>
        </AppButton>
      </div>
    </div>

    <div
      v-if="goodsInfo.description"
      class="goodsInfo-block area-description">
      <div class="goodsInfo-title">Описание</div>
      <div
        class="goodsInfo-text"
        :class="{'-hidden': isDescriptionTextHidden }">
        <div v-html="goodsInfo.description"/>
        <AppButton
          class="buttonAsLink buttonMore"
          @click.native="isDescriptionTextHidden = !isDescriptionTextHidden">
          <template #button-item>
            {{ isDescriptionTextHidden ? 'см.все' : 'свернуть' }}
          </template>
        </AppButton>
      </div>
    </div>
    <div
      v-if="!goodsInfo.description && !goodsInfo.aliases && goodsInfo.images.length"
      class="goodsInfo-block area-aliases">
      <div class="goodsInfo-title">Описание</div>
      <div class="goodsInfo-text">
        Мы скоро добавим описание данного товара
      </div>
    </div>


    <no-ssr>
      <vue-easy-lightbox
        :visible="isLightBox"
        :imgs="currentImages"
        v-scroll-lock="isLightBox"
        @hide="onCloseLightBox"/>
    </no-ssr>
  </div>
</template>

<script>
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'GoodsInfo',
  components: {
    AppButton,
  },
  props: {
    goodsInfo: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      currentImages: [],
      isLightBox: false,
      isAliasesTextHidden: true,
      isDescriptionTextHidden: true,
    };
  },
  methods: {
    onClickChooseImg(url) {
      this.currentImages.push(url);
      this.isLightBox = true;
    },
    onCloseLightBox() {
      this.currentImages = [];
      this.isLightBox = false;
    },
  },
};
</script>

<style lang="postcss">
.goodsInfo {
  &-text {
    ul {
      margin-left: 1.5rem;
      font: inherit;
      list-style: disc;
    }

    p {
      margin: 0;
      padding-bottom: 0.5rem;
      font: inherit;
    }
  }
}
</style>

<style scoped lang="postcss">
.goodsInfo {
  &.container-grid {
    display: grid;

    .area-slider {
      grid-area: slider;
    }

    .area-relevance {
      grid-area: relevance;
    }

    .area-aliases {
      grid-area: aliases;
    }

    .area-description {
      grid-area: description;
    }
  }

  &-title {
    display: block;
    padding-bottom: 0.25rem;
    font-size: inherit;
    font-weight: var(--font-weight-bold);
  }

  &-counter {
    display: flex;
    flex-direction: column;

    .value {
      padding-bottom: 0.375rem;
      white-space: nowrap;
    }
  }

  &-text {
    max-width: 40rem;
    font-size: inherit;

    &.-hidden {
      position: relative;
      overflow: hidden;
      &:after {
        content: "";
        position: absolute;
        right: 0;
        top: auto;
        bottom: 0;
        display: block;
        width: 7rem;
        height: 1.4em;
        background-image: linear-gradient(270deg, rgba(255,255,255,1) 50%, rgba(255,255,255,0));
      }

      .buttonMore {
        position: absolute;
        z-index: 1;
        bottom: 0;
        right: 0;
        display: block;
        padding: 0;
        min-height: 1.25rem;
        font: inherit;
        background-color: var(--bg-main);
      }
    }
  }

  @media screen and (min-width: 981px) {
    font-size: 0.875rem;

    &.-is-mobile {
      display: none;
    }

    &.container-grid {
      grid-template-columns: auto 1fr;
      grid-template-rows: auto 1fr;
      grid-template-areas: "slider aliases" "slider description";
    }

    &-slider {
      .picture {
        width: 9.125rem;
        margin-right: 1.5rem;
        margin-bottom: 1rem;
        padding-top: 7.5rem;
        border: 1px solid var(--border-color-main);
        cursor: pointer;

        > img {
          width: auto;
          height: auto;
          max-width: 100%;
          max-height: 100%;
        }
      }
    }

    &-block {
      padding-bottom: 1rem;
    }

    &-text {
      &.-hidden {
        max-height: 2.375rem;
      }
    }
  }

  @media screen and (max-width: 980px) {
    margin: 0;
    padding: 0;

    &.-is-desktop {
      display: none;
    }

    &.container-grid {
      grid-template-columns: auto 1fr;
      grid-template-areas: "slider aliases" "description description";
    }

    &-counter {
      align-items: flex-end;
      padding-bottom: 0;
      padding-left: 0.75rem;
    }

    &-title {
      padding-bottom: 0.5rem;
      font-weight: var(--font-weight-medium);
    }

    &-block {
      padding: 0 1.25rem 1rem;
      font-size: 0.875rem;
    }

    &-slider {
      padding: 0 0 1rem 1.25rem;

      .picture {
        width: 4rem;
        margin: 0 auto;
        padding-top: 4rem;
        border: 1px solid var(--border-color-main);
        > img {
          width: auto;
          height: auto;
          max-width: 100%;
          max-height: 100%;
        }
      }
    }

    &-text {
      &.-hidden {
        max-height: 2.375rem;
      }

      .buttonMore {
        padding: 0.5rem 0;
        font: inherit;
      }
    }
  }
}
</style>
